﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Threading;
using FarPoint.Win.Spread;

namespace ThreadingTest
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    private void button1_Click(object sender, EventArgs e)
    {
      Form2 f2 = new Form2();
      Thread thread = new Thread(new ParameterizedThreadStart(UpdateRandomValue));

      thread.Start(f2.fpSpread1);
      f2.Show();
    }

    private void button2_Click(object sender, EventArgs e)
    {

    }

    private void UpdateRandomValue(object spread)
    {
      FpSpread fpSpread = (FpSpread)spread;

      Random rnd = new Random();
      for (int i = 0; i < 100000; i++)
      {
        //Thread.Sleep(100);

        int opt = rnd.Next(0, 3), r = rnd.Next(0, 40), c = rnd.Next(0, 20);

        StyleInfo styleInfo = new StyleInfo();
        switch(opt)
        {
          case 0:
            styleInfo.Font = new Font("Arial", 10, FontStyle.Bold);
            styleInfo.ForeColor = Color.Red;
            styleInfo.BackColor = Color.Yellow;
            break;
          case 1:
            styleInfo.Font = new Font("Times New Roman", 15, FontStyle.Italic);
            styleInfo.ForeColor = Color.Blue;
            styleInfo.BackColor = Color.Gray;
            break;
          case 2:
            styleInfo.Font = new Font("Calibri", 20, FontStyle.Strikeout);
            styleInfo.ForeColor = Color.Green;
            styleInfo.BackColor = Color.Orange;
            break;
          case 3:
            styleInfo.Font = new Font("Comic San MS", 30, FontStyle.Regular);
            styleInfo.ForeColor = Color.Orange;
            styleInfo.BackColor = Color.WhiteSmoke;
            break;
        }
        fpSpread.ActiveSheet.SetStyleInfo(r, c, styleInfo);
        fpSpread.ActiveSheet.SetValue(r, c, rnd.Next(int.MinValue, int.MaxValue));

        //fpSpread1.ActiveSheet.Cells[r, c].Font = styleInfo.Font;
        //fpSpread1.ActiveSheet.Cells[r, c].ForeColor = styleInfo.ForeColor;
        //fpSpread1.ActiveSheet.Cells[r, c].Value = rnd.Next(int.MinValue, int.MaxValue);
      }
    }

    private void Form1_Load(object sender, EventArgs e)
    {
      fpSpread1.ActiveSheet.RowCount = 10000;
      fpSpread1.ActiveSheet.ColumnCount = 10000;
      FarPoint.Win.Spread.CellType.RichTextCellType richTextCell = new FarPoint.Win.Spread.CellType.RichTextCellType();
      richTextCell.Multiline = true;
      richTextCell.WordWrap = true;
      fpSpread1.ActiveSheet.DefaultStyle.CellType = richTextCell;
    }
  }
}
